Fix handling of broken tests.
[notmuch] / test / test-lib.sh
1 #!/bin/bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # if --tee was passed, write the output not only to the terminal, but
27 # additionally to the file test-results/$BASENAME.out, too.
28 case "$GIT_TEST_TEE_STARTED, $* " in
29 done,*)
30         # do not redirect again
31         ;;
32 *' --tee '*|*' --va'*)
33         mkdir -p test-results
34         BASE=test-results/$(basename "$0" .sh)
35         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
36          echo $? > $BASE.exit) | tee $BASE.out
37         test "$(cat $BASE.exit)" = 0
38         exit
39         ;;
40 esac
41
42 # Keep the original TERM for say_color
43 ORIGINAL_TERM=$TERM
44
45 # For repeatability, reset the environment to known value.
46 LANG=C
47 LC_ALL=C
48 PAGER=cat
49 TZ=UTC
50 TERM=dumb
51 export LANG LC_ALL PAGER TERM TZ
52 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
53
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
56 unset CDPATH
57
58 unset GREP_OPTIONS
59
60 # Convenience
61 #
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
65
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
68
69 # Each test should start with something like this, after copyright notices:
70 #
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
73 # '
74 # . ./test-lib.sh
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76                 TERM=$ORIGINAL_TERM &&
77                 export TERM &&
78                 [ -t 1 ] &&
79                 tput bold >/dev/null 2>&1 &&
80                 tput setaf 1 >/dev/null 2>&1 &&
81                 tput sgr0 >/dev/null 2>&1
82         ) &&
83         color=t
84
85 while test "$#" -ne 0
86 do
87         case "$1" in
88         -d|--d|--de|--deb|--debu|--debug)
89                 debug=t; shift ;;
90         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
91                 immediate=t; shift ;;
92         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94         -h|--h|--he|--hel|--help)
95                 help=t; shift ;;
96         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
97                 verbose=t; shift ;;
98         -q|--q|--qu|--qui|--quie|--quiet)
99                 quiet=t; shift ;;
100         --with-dashes)
101                 with_dashes=t; shift ;;
102         --no-color)
103                 color=; shift ;;
104         --no-python)
105                 # noop now...
106                 shift ;;
107         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108                 valgrind=t; verbose=t; shift ;;
109         --tee)
110                 shift ;; # was handled already
111         --root=*)
112                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
113                 shift ;;
114         *)
115                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
116         esac
117 done
118
119 if test -n "$color"; then
120         say_color () {
121                 (
122                 TERM=$ORIGINAL_TERM
123                 export TERM
124                 case "$1" in
125                         error) tput bold; tput setaf 1;; # bold red
126                         skip)  tput bold; tput setaf 2;; # bold green
127                         pass)  tput setaf 2;;            # green
128                         info)  tput setaf 3;;            # brown
129                         *) test -n "$quiet" && return;;
130                 esac
131                 shift
132                 printf " "
133                 printf "$@"
134                 tput sgr0
135                 )
136         }
137 else
138         say_color() {
139                 test -z "$1" && test -n "$quiet" && return
140                 shift
141                 printf " "
142                 printf "$@"
143         }
144 fi
145
146 error () {
147         say_color error "error: $*\n"
148         GIT_EXIT_OK=t
149         exit 1
150 }
151
152 say () {
153         say_color info "$*"
154 }
155
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
158
159 if test "$help" = "t"
160 then
161         echo "Tests ${test_description}"
162         exit 0
163 fi
164
165 echo $(basename "$0"): "Testing ${test_description}"
166
167 exec 5>&1
168
169 test_failure=0
170 test_count=0
171 test_fixed=0
172 test_broken=0
173 test_success=0
174
175 die () {
176         code=$?
177         if test -n "$GIT_EXIT_OK"
178         then
179                 exit $code
180         else
181                 echo >&5 "FATAL: Unexpected exit with code $code"
182                 exit 1
183         fi
184 }
185
186 GIT_EXIT_OK=
187 trap 'die' EXIT
188
189 test_decode_color () {
190         sed     -e 's/.\[1m/<WHITE>/g' \
191                 -e 's/.\[31m/<RED>/g' \
192                 -e 's/.\[32m/<GREEN>/g' \
193                 -e 's/.\[33m/<YELLOW>/g' \
194                 -e 's/.\[34m/<BLUE>/g' \
195                 -e 's/.\[35m/<MAGENTA>/g' \
196                 -e 's/.\[36m/<CYAN>/g' \
197                 -e 's/.\[m/<RESET>/g'
198 }
199
200 q_to_nul () {
201         perl -pe 'y/Q/\000/'
202 }
203
204 q_to_cr () {
205         tr Q '\015'
206 }
207
208 append_cr () {
209         sed -e 's/$/Q/' | tr Q '\015'
210 }
211
212 remove_cr () {
213         tr '\015' Q | sed -e 's/Q$//'
214 }
215
216 # Notmuch helper functions
217 increment_mtime_amount=0
218 increment_mtime ()
219 {
220     dir="$1"
221
222     increment_mtime_amount=$((increment_mtime_amount + 1))
223     touch -d "+${increment_mtime_amount} seconds" "$dir"
224 }
225
226 # Generate a new message in the mail directory, with a unique message
227 # ID and subject. The message is not added to the index.
228 #
229 # After this function returns, the filename of the generated message
230 # is available as $gen_msg_filename and the message ID is available as
231 # $gen_msg_id .
232 #
233 # This function supports named parameters with the bash syntax for
234 # assigning a value to an associative array ([name]=value). The
235 # supported parameters are:
236 #
237 #  [dir]=directory/of/choice
238 #
239 #       Generate the message in directory 'directory/of/choice' within
240 #       the mail store. The directory will be created if necessary.
241 #
242 #  [filename]=name
243 #
244 #       Store the message in file 'name'. The default is to store it
245 #       in 'msg-<count>', where <count> is three-digit number of the
246 #       message.
247 #       
248 #  [body]=text
249 #
250 #       Text to use as the body of the email message
251 #
252 #  '[from]="Some User <user@example.com>"'
253 #  '[to]="Some User <user@example.com>"'
254 #  '[subject]="Subject of email message"'
255 #  '[date]="RFC 822 Date"'
256 #
257 #       Values for email headers. If not provided, default values will
258 #       be generated instead.
259 #
260 #  '[cc]="Some User <user@example.com>"'
261 #  [reply-to]=some-address
262 #  [in-reply-to]=<message-id>
263 #  [references]=<message-id>
264 #  [content-type]=content-type-specification
265 #  '[header]=full header line, including keyword'
266 #
267 #       Additional values for email headers. If these are not provided
268 #       then the relevant headers will simply not appear in the
269 #       message.
270 #
271 #  '[id]=message-id'
272 #
273 #       Controls the message-id of the created message.
274 gen_msg_cnt=0
275 gen_msg_filename=""
276 gen_msg_id=""
277 generate_message ()
278 {
279     # This is our (bash-specific) magic for doing named parameters
280     local -A template="($@)"
281     local additional_headers
282
283     gen_msg_cnt=$((gen_msg_cnt + 1))
284     if [ -z "${template[filename]}" ]; then
285         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
286     else
287         gen_msg_name=${template[filename]}
288     fi
289
290     if [ -z "${template[id]}" ]; then
291         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
292     else
293         gen_msg_id="${template[id]}"
294     fi
295
296     if [ -z "${template[dir]}" ]; then
297         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
298     else
299         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
300         mkdir -p "$(dirname "$gen_msg_filename")"
301     fi
302
303     if [ -z "${template[body]}" ]; then
304         template[body]="This is just a test message (#${gen_msg_cnt})"
305     fi
306
307     if [ -z "${template[from]}" ]; then
308         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
309     fi
310
311     if [ -z "${template[to]}" ]; then
312         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
313     fi
314
315     if [ -z "${template[subject]}" ]; then
316         template[subject]="Test message #${gen_msg_cnt}"
317     fi
318
319     if [ -z "${template[date]}" ]; then
320         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
321     fi
322
323     additional_headers=""
324     if [ ! -z "${template[header]}" ]; then
325         additional_headers="${template[header]}
326 ${additional_headers}"
327     fi
328
329     if [ ! -z "${template[reply-to]}" ]; then
330         additional_headers="Reply-To: ${template[reply-to]}
331 ${additional_headers}"
332     fi
333
334     if [ ! -z "${template[in-reply-to]}" ]; then
335         additional_headers="In-Reply-To: ${template[in-reply-to]}
336 ${additional_headers}"
337     fi
338
339     if [ ! -z "${template[cc]}" ]; then
340         additional_headers="Cc: ${template[cc]}
341 ${additional_headers}"
342     fi
343
344     if [ ! -z "${template[references]}" ]; then
345         additional_headers="References: ${template[references]}
346 ${additional_headers}"
347     fi
348
349     if [ ! -z "${template[content-type]}" ]; then
350         additional_headers="Content-Type: ${template[content-type]}
351 ${additional_headers}"
352     fi
353
354
355 cat <<EOF >"$gen_msg_filename"
356 From: ${template[from]}
357 To: ${template[to]}
358 Message-Id: <${gen_msg_id}>
359 Subject: ${template[subject]}
360 Date: ${template[date]}
361 ${additional_headers}
362 ${template[body]}
363 EOF
364
365     # Ensure that the mtime of the containing directory is updated
366     increment_mtime "$(dirname "${gen_msg_filename}")"
367 }
368
369 # Generate a new message and add it to the database.
370 #
371 # All of the arguments and return values supported by generate_message
372 # are also supported here, so see that function for details.
373 add_message ()
374 {
375     generate_message "$@" &&
376     notmuch new > /dev/null
377 }
378
379 # Generate a corpus of email and add it to the database.
380 #
381 # This corpus is fixed, (it happens to be 50 messages from early in
382 # the history of the notmuch mailing list), which allows for reliably
383 # testing commands that need to operate on a not-totally-trivial
384 # number of messages.
385 add_email_corpus ()
386 {
387     rm -rf ${MAIL_DIR}
388     if [ -d ../corpus.mail ]; then
389         cp -a ../corpus.mail ${MAIL_DIR}
390     else
391         cp -a ../corpus ${MAIL_DIR}
392         notmuch new >/dev/null
393         cp -a ${MAIL_DIR} ../corpus.mail
394     fi
395 }
396
397 test_begin_subtest ()
398 {
399     if [ -n "$inside_subtest" ]; then
400         exec 1>&6 2>&7          # Restore stdout and stderr
401         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
402     fi
403     test_subtest_name="$1"
404     # Remember stdout and stderr file descriptios and redirect test
405     # output to the previously prepared file descriptors 3 and 4 (see
406     # bellow)
407     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
408     exec 6>&1 7>&2 >&3 2>&4
409     inside_subtest=t
410 }
411
412 # Pass test if two arguments match
413 #
414 # Note: Unlike all other test_expect_* functions, this function does
415 # not accept a test name. Instead, the caller should call
416 # test_begin_subtest before calling this function in order to set the
417 # name.
418 test_expect_equal ()
419 {
420         exec 1>&6 2>&7          # Restore stdout and stderr
421         inside_subtest=
422         test "$#" = 3 && { prereq=$1; shift; } || prereq=
423         test "$#" = 2 ||
424         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
425
426         output="$1"
427         expected="$2"
428         if ! test_skip "$@"
429         then
430                 if [ "$output" = "$expected" ]; then
431                         test_ok_ "$test_subtest_name"
432                 else
433                         testname=$this_test.$test_count
434                         echo "$expected" > $testname.expected
435                         echo "$output" > $testname.output
436                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
437                 fi
438     fi
439 }
440
441 test_expect_equal_failure ()
442 {
443         exec 1>&6 2>&7          # Restore stdout and stderr
444         inside_subtest=
445         test "$#" = 3 && { prereq=$1; shift; } || prereq=
446         test "$#" = 2 ||
447         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
448
449         output="$1"
450         expected="$2"
451         if ! test_skip "$@"
452         then
453                 if [ "$output" = "$expected" ]; then
454                         test_known_broken_ok_ "$test_subtest_name"
455                 else
456                         test_known_broken_failure_ "$test_subtest_name"
457                 fi
458     fi
459 }
460
461 NOTMUCH_NEW ()
462 {
463     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
464 }
465
466 notmuch_search_sanitize ()
467 {
468     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
469 }
470
471 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
472 notmuch_show_sanitize ()
473 {
474     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
475 }
476
477 # End of notmuch helper functions
478
479 # Use test_set_prereq to tell that a particular prerequisite is available.
480 # The prerequisite can later be checked for in two ways:
481 #
482 # - Explicitly using test_have_prereq.
483 #
484 # - Implicitly by specifying the prerequisite tag in the calls to
485 #   test_expect_{success,failure,code}.
486 #
487 # The single parameter is the prerequisite tag (a simple word, in all
488 # capital letters by convention).
489
490 test_set_prereq () {
491         satisfied="$satisfied$1 "
492 }
493 satisfied=" "
494
495 test_have_prereq () {
496         case $satisfied in
497         *" $1 "*)
498                 : yes, have it ;;
499         *)
500                 ! : nope ;;
501         esac
502 }
503
504 # You are not expected to call test_ok_ and test_failure_ directly, use
505 # the text_expect_* functions instead.
506
507 test_ok_ () {
508         test_success=$(($test_success + 1))
509         say_color pass "%-6s" "PASS"
510         echo " $@"
511 }
512
513 test_failure_ () {
514         test_failure=$(($test_failure + 1))
515         say_color error "%-6s" "FAIL"
516         echo " $1"
517         shift
518         echo "$@" | sed -e 's/^/        /'
519         if test "$verbose" != "t"; then cat test.output; fi
520         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
521 }
522
523 test_known_broken_ok_ () {
524         test_fixed=$(($test_fixed+1))
525         say_color pass "%-6s" "FIXED"
526         echo " $@"
527 }
528
529 test_known_broken_failure_ () {
530         test_broken=$(($test_broken+1))
531         say_color pass "%-6s" "BROKEN"
532         echo " $@"
533 }
534
535 test_debug () {
536         test "$debug" = "" || eval "$1"
537 }
538
539 test_run_ () {
540         test_cleanup=:
541         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
542         eval >&3 2>&4 "$1"
543         eval_ret=$?
544         eval >&3 2>&4 "$test_cleanup"
545         return 0
546 }
547
548 test_skip () {
549         test_count=$(($test_count+1))
550         to_skip=
551         for skp in $NOTMUCH_SKIP_TESTS
552         do
553                 case $this_test.$test_count in
554                 $skp)
555                         to_skip=t
556                 esac
557         done
558         if test -z "$to_skip" && test -n "$prereq" &&
559            ! test_have_prereq "$prereq"
560         then
561                 to_skip=t
562         fi
563         case "$to_skip" in
564         t)
565                 say_color skip >&3 "skipping test: $@"
566                 say_color skip "%-6s" "SKIP"
567                 echo " $1"
568                 : true
569                 ;;
570         *)
571                 false
572                 ;;
573         esac
574 }
575
576 test_expect_failure () {
577         test "$#" = 3 && { prereq=$1; shift; } || prereq=
578         test "$#" = 2 ||
579         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
580         if ! test_skip "$@"
581         then
582                 test_run_ "$2"
583                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
584                 then
585                         test_known_broken_ok_ "$1"
586                 else
587                         test_known_broken_failure_ "$1"
588                 fi
589         fi
590 }
591
592 test_expect_success () {
593         test "$#" = 3 && { prereq=$1; shift; } || prereq=
594         test "$#" = 2 ||
595         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
596         if ! test_skip "$@"
597         then
598                 test_run_ "$2"
599                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
600                 then
601                         test_ok_ "$1"
602                 else
603                         test_failure_ "$@"
604                 fi
605         fi
606 }
607
608 test_expect_code () {
609         test "$#" = 4 && { prereq=$1; shift; } || prereq=
610         test "$#" = 3 ||
611         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
612         if ! test_skip "$@"
613         then
614                 test_run_ "$3"
615                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
616                 then
617                         test_ok_ "$2"
618                 else
619                         test_failure_ "$@"
620                 fi
621         fi
622 }
623
624 # test_external runs external test scripts that provide continuous
625 # test output about their progress, and succeeds/fails on
626 # zero/non-zero exit code.  It outputs the test output on stdout even
627 # in non-verbose mode, and announces the external script with "* run
628 # <n>: ..." before running it.  When providing relative paths, keep in
629 # mind that all scripts run in "trash directory".
630 # Usage: test_external description command arguments...
631 # Example: test_external 'Perl API' perl ../path/to/test.pl
632 test_external () {
633         test "$#" = 4 && { prereq=$1; shift; } || prereq=
634         test "$#" = 3 ||
635         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
636         descr="$1"
637         shift
638         if ! test_skip "$descr" "$@"
639         then
640                 # Announce the script to reduce confusion about the
641                 # test output that follows.
642                 say_color "" " run $test_count: $descr ($*)"
643                 # Run command; redirect its stderr to &4 as in
644                 # test_run_, but keep its stdout on our stdout even in
645                 # non-verbose mode.
646                 "$@" 2>&4
647                 if [ "$?" = 0 ]
648                 then
649                         test_ok_ "$descr"
650                 else
651                         test_failure_ "$descr" "$@"
652                 fi
653         fi
654 }
655
656 # Like test_external, but in addition tests that the command generated
657 # no output on stderr.
658 test_external_without_stderr () {
659         # The temporary file has no (and must have no) security
660         # implications.
661         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
662         stderr="$tmp/git-external-stderr.$$.tmp"
663         test_external "$@" 4> "$stderr"
664         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
665         descr="no stderr: $1"
666         shift
667         if [ ! -s "$stderr" ]; then
668                 rm "$stderr"
669                 test_ok_ "$descr"
670         else
671                 if [ "$verbose" = t ]; then
672                         output=`echo; echo Stderr is:; cat "$stderr"`
673                 else
674                         output=
675                 fi
676                 # rm first in case test_failure exits.
677                 rm "$stderr"
678                 test_failure_ "$descr" "$@" "$output"
679         fi
680 }
681
682 # This is not among top-level (test_expect_success | test_expect_failure)
683 # but is a prefix that can be used in the test script, like:
684 #
685 #       test_expect_success 'complain and die' '
686 #           do something &&
687 #           do something else &&
688 #           test_must_fail git checkout ../outerspace
689 #       '
690 #
691 # Writing this as "! git checkout ../outerspace" is wrong, because
692 # the failure could be due to a segv.  We want a controlled failure.
693
694 test_must_fail () {
695         "$@"
696         test $? -gt 0 -a $? -le 129 -o $? -gt 192
697 }
698
699 # test_cmp is a helper function to compare actual and expected output.
700 # You can use it like:
701 #
702 #       test_expect_success 'foo works' '
703 #               echo expected >expected &&
704 #               foo >actual &&
705 #               test_cmp expected actual
706 #       '
707 #
708 # This could be written as either "cmp" or "diff -u", but:
709 # - cmp's output is not nearly as easy to read as diff -u
710 # - not all diff versions understand "-u"
711
712 test_cmp() {
713         $GIT_TEST_CMP "$@"
714 }
715
716 # This function can be used to schedule some commands to be run
717 # unconditionally at the end of the test to restore sanity:
718 #
719 #       test_expect_success 'test core.capslock' '
720 #               git config core.capslock true &&
721 #               test_when_finished "git config --unset core.capslock" &&
722 #               hello world
723 #       '
724 #
725 # That would be roughly equivalent to
726 #
727 #       test_expect_success 'test core.capslock' '
728 #               git config core.capslock true &&
729 #               hello world
730 #               git config --unset core.capslock
731 #       '
732 #
733 # except that the greeting and config --unset must both succeed for
734 # the test to pass.
735
736 test_when_finished () {
737         test_cleanup="{ $*
738                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
739 }
740
741 test_done () {
742         GIT_EXIT_OK=t
743         test_results_dir="$TEST_DIRECTORY/test-results"
744         mkdir -p "$test_results_dir"
745         test_results_path="$test_results_dir/${0%.sh}-$$"
746
747         echo "total $test_count" >> $test_results_path
748         echo "success $test_success" >> $test_results_path
749         echo "fixed $test_fixed" >> $test_results_path
750         echo "broken $test_broken" >> $test_results_path
751         echo "failed $test_failure" >> $test_results_path
752         echo "" >> $test_results_path
753
754         echo
755
756         if [ "$test_failure" = "0" ]; then
757             rm -rf "$remove_tmp"
758             exit 0
759         else
760             exit 1
761         fi
762 }
763
764 test_emacs () {
765         # Construct a little test script here for the benefit of the user,
766         # (who can easily run "run_emacs" to get the same emacs environment
767         # for investigating any failures).    
768         cat <<EOF > run_emacs
769 #!/bin/sh
770 export PATH=$PATH
771 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
772
773 # We assume that the user will give a command-line argument only if
774 # wanting to run in batch mode.
775 if [ \$# -gt 0 ]; then
776         BATCH=--batch
777 fi
778
779 # Here's what we are using here:
780 #
781 # --batch:              Quit after given commands and print all (messages)
782 #
783 # --no-init-file        Don't load users ~/.emacs
784 #
785 # --no-site-file        Don't load the site-wide startup stuff
786 #
787 # --directory           Ensure that the local notmuch.el source is found
788 #
789 # --load                Force loading of notmuch.el
790 #
791 # notmuch-test-wait     Function for tests to use to wait for process completion
792 #
793 # message-signature     Avoiding appending user's signature on messages
794 #
795 # set-frame-width       80 columns (avoids crazy 10-column default of --batch)
796
797 emacs \$BATCH --no-init-file --no-site-file \
798         --directory ../../emacs --load notmuch.el \
799         --eval "(defun notmuch-test-wait ()
800                         (while (get-buffer-process (current-buffer))
801                                 (sleep-for 0.1)))" \
802         --eval "(setq message-signature nil)" \
803         --eval "(progn (set-frame-width (window-frame (get-buffer-window)) 80) \$@)"
804 EOF
805         chmod a+x ./run_emacs
806         ./run_emacs "$@"
807 }
808
809
810 find_notmuch_path ()
811 {
812     dir="$1"
813
814     while [ -n "$dir" ]; do
815         bin="$dir/notmuch"
816         if [ -x "$bin" ]; then
817             echo "$dir"
818             return
819         fi
820         dir="$(dirname "$dir")"
821         if [ "$dir" = "/" ]; then
822             break
823         fi
824     done
825 }
826
827 # Test the binaries we have just built.  The tests are kept in
828 # test/ subdirectory and are run in 'trash directory' subdirectory.
829 TEST_DIRECTORY=$(pwd)
830 if test -n "$valgrind"
831 then
832         make_symlink () {
833                 test -h "$2" &&
834                 test "$1" = "$(readlink "$2")" || {
835                         # be super paranoid
836                         if mkdir "$2".lock
837                         then
838                                 rm -f "$2" &&
839                                 ln -s "$1" "$2" &&
840                                 rm -r "$2".lock
841                         else
842                                 while test -d "$2".lock
843                                 do
844                                         say "Waiting for lock on $2."
845                                         sleep 1
846                                 done
847                         fi
848                 }
849         }
850
851         make_valgrind_symlink () {
852                 # handle only executables
853                 test -x "$1" || return
854
855                 base=$(basename "$1")
856                 symlink_target=$TEST_DIRECTORY/../$base
857                 # do not override scripts
858                 if test -x "$symlink_target" &&
859                     test ! -d "$symlink_target" &&
860                     test "#!" != "$(head -c 2 < "$symlink_target")"
861                 then
862                         symlink_target=../valgrind.sh
863                 fi
864                 case "$base" in
865                 *.sh|*.perl)
866                         symlink_target=../unprocessed-script
867                 esac
868                 # create the link, or replace it if it is out of date
869                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
870         }
871
872         # override notmuch executable in TEST_DIRECTORY/..
873         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
874         mkdir -p "$GIT_VALGRIND"/bin
875         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
876         OLDIFS=$IFS
877         IFS=:
878         for path in $PATH
879         do
880                 ls "$path"/notmuch 2> /dev/null |
881                 while read file
882                 do
883                         make_valgrind_symlink "$file"
884                 done
885         done
886         IFS=$OLDIFS
887         PATH=$GIT_VALGRIND/bin:$PATH
888         GIT_EXEC_PATH=$GIT_VALGRIND/bin
889         export GIT_VALGRIND
890 else # normal case
891         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
892         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
893 fi
894 export PATH
895
896 # Test repository
897 test="tmp.$(basename "$0" .sh)"
898 test -n "$root" && test="$root/$test"
899 case "$test" in
900 /*) TMP_DIRECTORY="$test" ;;
901  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
902 esac
903 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
904 rm -fr "$test" || {
905         GIT_EXIT_OK=t
906         echo >&5 "FATAL: Cannot prepare test area"
907         exit 1
908 }
909
910 MAIL_DIR="${TMP_DIRECTORY}/mail"
911 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
912
913 mkdir -p "${test}"
914 mkdir -p "${MAIL_DIR}"
915
916 cat <<EOF >"${NOTMUCH_CONFIG}"
917 [database]
918 path=${MAIL_DIR}
919
920 [user]
921 name=Notmuch Test Suite
922 primary_email=test_suite@notmuchmail.org
923 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
924 EOF
925
926
927 # Use -P to resolve symlinks in our working directory so that the cwd
928 # in subprocesses like git equals our $PWD (for pathname comparisons).
929 cd -P "$test" || error "Cannot setup test environment"
930
931 if test "$verbose" = "t"
932 then
933         exec 4>&2 3>&1
934 else
935         exec 4>test.output 3>&4
936 fi
937
938 this_test=${0##*/}
939 for skp in $NOTMUCH_SKIP_TESTS
940 do
941         to_skip=
942         for skp in $NOTMUCH_SKIP_TESTS
943         do
944                 case "$this_test" in
945                 $skp)
946                         to_skip=t
947                 esac
948         done
949         case "$to_skip" in
950         t)
951                 say_color skip >&3 "skipping test $this_test altogether"
952                 say_color skip "skip all tests in $this_test"
953                 test_done
954         esac
955 done
956
957 # Provide an implementation of the 'yes' utility
958 yes () {
959         if test $# = 0
960         then
961                 y=y
962         else
963                 y="$*"
964         fi
965
966         while echo "$y"
967         do
968                 :
969         done
970 }
971
972 # Fix some commands on Windows
973 case $(uname -s) in
974 *MINGW*)
975         # Windows has its own (incompatible) sort and find
976         sort () {
977                 /usr/bin/sort "$@"
978         }
979         find () {
980                 /usr/bin/find "$@"
981         }
982         sum () {
983                 md5sum "$@"
984         }
985         # git sees Windows-style pwd
986         pwd () {
987                 builtin pwd -W
988         }
989         # no POSIX permissions
990         # backslashes in pathspec are converted to '/'
991         # exec does not inherit the PID
992         ;;
993 *)
994         test_set_prereq POSIXPERM
995         test_set_prereq BSLASHPSPEC
996         test_set_prereq EXECKEEPSPID
997         ;;
998 esac
999
1000 test -z "$NO_PERL" && test_set_prereq PERL
1001 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1002
1003 # test whether the filesystem supports symbolic links
1004 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1005 rm -f y